Index: branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.EvolutionaryTracking.Views/3.4/LineageExplorerView.Designer.cs
===================================================================
--- branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.EvolutionaryTracking.Views/3.4/LineageExplorerView.Designer.cs	(revision 9834)
+++ branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.EvolutionaryTracking.Views/3.4/LineageExplorerView.Designer.cs	(revision 9835)
@@ -25,15 +25,16 @@
     private void InitializeComponent() {
       this.components = new System.ComponentModel.Container();
-      this.tabControl1 = new System.Windows.Forms.TabControl();
+      this.karyographTab = new System.Windows.Forms.TabControl();
       this.tabPage1 = new System.Windows.Forms.TabPage();
-      this.tabPage2 = new System.Windows.Forms.TabPage();
       this.panel1 = new System.Windows.Forms.Panel();
       this.qualityImprovementTreeView = new System.Windows.Forms.TreeView();
       this.symbolicExpressionTreeChart = new HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views.SymbolicExpressionTreeChart();
       this.scopeListTreeView = new System.Windows.Forms.TreeView();
+      this.panel2 = new System.Windows.Forms.Panel();
+      this.button1 = new System.Windows.Forms.Button();
+      this.showGenealogyButton = new System.Windows.Forms.Button();
       this.calculateFragmentFrequencyButton = new System.Windows.Forms.Button();
-      this.showGenealogyButton = new System.Windows.Forms.Button();
-      this.button1 = new System.Windows.Forms.Button();
-      this.panel2 = new System.Windows.Forms.Panel();
+      this.tabPage2 = new System.Windows.Forms.TabPage();
+      this.panel4 = new System.Windows.Forms.Panel();
       this.panel3 = new System.Windows.Forms.Panel();
       this.showFrequentFragmentsButton = new System.Windows.Forms.Button();
@@ -42,23 +43,26 @@
       this.bestNTextBox = new System.Windows.Forms.TextBox();
       this.consideredTrees = new System.Windows.Forms.Label();
-      this.panel4 = new System.Windows.Forms.Panel();
-      this.tabControl1.SuspendLayout();
+      this.tabPage3 = new System.Windows.Forms.TabPage();
+      this.karyograph1 = new HeuristicLab.EvolutionaryTracking.Views.Karyogram();
+      this.karyographTab.SuspendLayout();
       this.tabPage1.SuspendLayout();
-      this.tabPage2.SuspendLayout();
       this.panel1.SuspendLayout();
       this.panel2.SuspendLayout();
+      this.tabPage2.SuspendLayout();
       this.panel3.SuspendLayout();
+      this.tabPage3.SuspendLayout();
       this.SuspendLayout();
       // 
-      // tabControl1
-      // 
-      this.tabControl1.Controls.Add(this.tabPage1);
-      this.tabControl1.Controls.Add(this.tabPage2);
-      this.tabControl1.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.tabControl1.Location = new System.Drawing.Point(0, 0);
-      this.tabControl1.Name = "tabControl1";
-      this.tabControl1.SelectedIndex = 0;
-      this.tabControl1.Size = new System.Drawing.Size(1016, 669);
-      this.tabControl1.TabIndex = 2;
+      // karyographTab
+      // 
+      this.karyographTab.Controls.Add(this.tabPage1);
+      this.karyographTab.Controls.Add(this.tabPage2);
+      this.karyographTab.Controls.Add(this.tabPage3);
+      this.karyographTab.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.karyographTab.Location = new System.Drawing.Point(0, 0);
+      this.karyographTab.Name = "karyographTab";
+      this.karyographTab.SelectedIndex = 0;
+      this.karyographTab.Size = new System.Drawing.Size(1016, 669);
+      this.karyographTab.TabIndex = 2;
       // 
       // tabPage1
@@ -73,16 +77,4 @@
       this.tabPage1.Text = "Lineages";
       this.tabPage1.UseVisualStyleBackColor = true;
-      // 
-      // tabPage2
-      // 
-      this.tabPage2.Controls.Add(this.panel4);
-      this.tabPage2.Controls.Add(this.panel3);
-      this.tabPage2.Location = new System.Drawing.Point(4, 22);
-      this.tabPage2.Name = "tabPage2";
-      this.tabPage2.Padding = new System.Windows.Forms.Padding(3);
-      this.tabPage2.Size = new System.Drawing.Size(1008, 643);
-      this.tabPage2.TabIndex = 1;
-      this.tabPage2.Text = "Fragments";
-      this.tabPage2.UseVisualStyleBackColor = true;
       // 
       // panel1
@@ -134,4 +126,37 @@
       this.scopeListTreeView.AfterSelect += new System.Windows.Forms.TreeViewEventHandler(this.scopeListTreeView_AfterSelect);
       // 
+      // panel2
+      // 
+      this.panel2.Controls.Add(this.button1);
+      this.panel2.Controls.Add(this.showGenealogyButton);
+      this.panel2.Controls.Add(this.calculateFragmentFrequencyButton);
+      this.panel2.Dock = System.Windows.Forms.DockStyle.Top;
+      this.panel2.Location = new System.Drawing.Point(3, 3);
+      this.panel2.Name = "panel2";
+      this.panel2.Size = new System.Drawing.Size(1002, 33);
+      this.panel2.TabIndex = 1;
+      // 
+      // button1
+      // 
+      this.button1.AutoSize = true;
+      this.button1.Location = new System.Drawing.Point(239, 4);
+      this.button1.Name = "button1";
+      this.button1.Size = new System.Drawing.Size(135, 23);
+      this.button1.TabIndex = 2;
+      this.button1.Text = "Show frequent fragments";
+      this.button1.UseVisualStyleBackColor = true;
+      this.button1.Click += new System.EventHandler(this.button1_Click);
+      // 
+      // showGenealogyButton
+      // 
+      this.showGenealogyButton.AutoSize = true;
+      this.showGenealogyButton.Location = new System.Drawing.Point(129, 4);
+      this.showGenealogyButton.Name = "showGenealogyButton";
+      this.showGenealogyButton.Size = new System.Drawing.Size(104, 23);
+      this.showGenealogyButton.TabIndex = 1;
+      this.showGenealogyButton.Text = "Show genealogy";
+      this.showGenealogyButton.UseVisualStyleBackColor = true;
+      this.showGenealogyButton.Click += new System.EventHandler(this.showGenealogyButton_Click);
+      // 
       // calculateFragmentFrequencyButton
       // 
@@ -145,36 +170,23 @@
       this.calculateFragmentFrequencyButton.Click += new System.EventHandler(this.calculateFragmentFrequencyButton_Click);
       // 
-      // showGenealogyButton
-      // 
-      this.showGenealogyButton.AutoSize = true;
-      this.showGenealogyButton.Location = new System.Drawing.Point(129, 4);
-      this.showGenealogyButton.Name = "showGenealogyButton";
-      this.showGenealogyButton.Size = new System.Drawing.Size(104, 23);
-      this.showGenealogyButton.TabIndex = 1;
-      this.showGenealogyButton.Text = "Show genealogy";
-      this.showGenealogyButton.UseVisualStyleBackColor = true;
-      this.showGenealogyButton.Click += new System.EventHandler(this.showGenealogyButton_Click);
-      // 
-      // button1
-      // 
-      this.button1.AutoSize = true;
-      this.button1.Location = new System.Drawing.Point(239, 4);
-      this.button1.Name = "button1";
-      this.button1.Size = new System.Drawing.Size(135, 23);
-      this.button1.TabIndex = 2;
-      this.button1.Text = "Show frequent fragments";
-      this.button1.UseVisualStyleBackColor = true;
-      this.button1.Click += new System.EventHandler(this.button1_Click);
-      // 
-      // panel2
-      // 
-      this.panel2.Controls.Add(this.button1);
-      this.panel2.Controls.Add(this.showGenealogyButton);
-      this.panel2.Controls.Add(this.calculateFragmentFrequencyButton);
-      this.panel2.Dock = System.Windows.Forms.DockStyle.Top;
-      this.panel2.Location = new System.Drawing.Point(3, 3);
-      this.panel2.Name = "panel2";
-      this.panel2.Size = new System.Drawing.Size(1002, 33);
-      this.panel2.TabIndex = 1;
+      // tabPage2
+      // 
+      this.tabPage2.Controls.Add(this.panel4);
+      this.tabPage2.Controls.Add(this.panel3);
+      this.tabPage2.Location = new System.Drawing.Point(4, 22);
+      this.tabPage2.Name = "tabPage2";
+      this.tabPage2.Padding = new System.Windows.Forms.Padding(3);
+      this.tabPage2.Size = new System.Drawing.Size(1008, 643);
+      this.tabPage2.TabIndex = 1;
+      this.tabPage2.Text = "Fragments";
+      this.tabPage2.UseVisualStyleBackColor = true;
+      // 
+      // panel4
+      // 
+      this.panel4.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.panel4.Location = new System.Drawing.Point(3, 33);
+      this.panel4.Name = "panel4";
+      this.panel4.Size = new System.Drawing.Size(1002, 607);
+      this.panel4.TabIndex = 1;
       // 
       // panel3
@@ -236,11 +248,25 @@
       this.consideredTrees.Text = "Best n trees";
       // 
-      // panel4
-      // 
-      this.panel4.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.panel4.Location = new System.Drawing.Point(3, 33);
-      this.panel4.Name = "panel4";
-      this.panel4.Size = new System.Drawing.Size(1002, 607);
-      this.panel4.TabIndex = 1;
+      // tabPage3
+      // 
+      this.tabPage3.Controls.Add(this.karyograph1);
+      this.tabPage3.Location = new System.Drawing.Point(4, 22);
+      this.tabPage3.Name = "tabPage3";
+      this.tabPage3.Padding = new System.Windows.Forms.Padding(3);
+      this.tabPage3.Size = new System.Drawing.Size(1008, 643);
+      this.tabPage3.TabIndex = 2;
+      this.tabPage3.Text = "Karyograph";
+      this.tabPage3.UseVisualStyleBackColor = true;
+      // 
+      // karyograph1
+      // 
+      this.karyograph1.BackColor = System.Drawing.SystemColors.Control;
+      this.karyograph1.Chart = null;
+      this.karyograph1.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.karyograph1.Location = new System.Drawing.Point(3, 3);
+      this.karyograph1.Name = "karyograph1";
+      this.karyograph1.ScaleOnResize = true;
+      this.karyograph1.Size = new System.Drawing.Size(1002, 637);
+      this.karyograph1.TabIndex = 0;
       // 
       // LineageExplorerView
@@ -248,15 +274,16 @@
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
-      this.Controls.Add(this.tabControl1);
+      this.Controls.Add(this.karyographTab);
       this.Name = "LineageExplorerView";
       this.Size = new System.Drawing.Size(1016, 669);
-      this.tabControl1.ResumeLayout(false);
+      this.karyographTab.ResumeLayout(false);
       this.tabPage1.ResumeLayout(false);
-      this.tabPage2.ResumeLayout(false);
       this.panel1.ResumeLayout(false);
       this.panel2.ResumeLayout(false);
       this.panel2.PerformLayout();
+      this.tabPage2.ResumeLayout(false);
       this.panel3.ResumeLayout(false);
       this.panel3.PerformLayout();
+      this.tabPage3.ResumeLayout(false);
       this.ResumeLayout(false);
 
@@ -265,5 +292,5 @@
     #endregion
 
-    private System.Windows.Forms.TabControl tabControl1;
+    private System.Windows.Forms.TabControl karyographTab;
     private System.Windows.Forms.TabPage tabPage1;
     private System.Windows.Forms.Panel panel1;
@@ -283,4 +310,6 @@
     private System.Windows.Forms.Label consideredTrees;
     private System.Windows.Forms.Panel panel4;
+    private System.Windows.Forms.TabPage tabPage3;
+    private Karyogram karyograph1;
 
 
Index: branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.EvolutionaryTracking.Views/3.4/LineageExplorerView.cs
===================================================================
--- branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.EvolutionaryTracking.Views/3.4/LineageExplorerView.cs	(revision 9834)
+++ branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.EvolutionaryTracking.Views/3.4/LineageExplorerView.cs	(revision 9835)
@@ -59,4 +59,6 @@
         }
       }
+
+      karyograph1.Trees = Content.Trees.OrderByDescending(x => x.Item2).Select(x => x.Item1).ToList();
     }
 
@@ -155,5 +157,5 @@
       var trees = Content.GenealogyGraph.Nodes.Where(x => x.Rank.IsAlmost(graphNode.Rank)).Select(x => x.SymbolicExpressionTree).ToList();
 
-      var fragments = graphNode.SymbolicExpressionTree.IterateNodesBreadth().Select(n => new Fragment(n));
+      var fragments = graphNode.SymbolicExpressionTree.IterateNodesBreadth().Select(n => new Fragment { Root = n });
 
       var similarityComparer = new SymbolicExpressionTreeNodeSimilarityComparer {
@@ -241,5 +243,5 @@
       };
 
-      var fragments = bestTrees.SelectMany(t => t.IterateNodesBreadth()).Where(n => n.GetLength() >= 3).Distinct(similarityComparer).Select(n => new Fragment(n));
+      var fragments = bestTrees.SelectMany(t => t.IterateNodesBreadth()).Where(n => n.GetLength() >= 3).Distinct(similarityComparer).Select(n => new Fragment { Root = n });
 
       double bestNQuality = tuples.Take(bestN).Sum(x => x.Quality); // average quality of best N individuals in the population
Index: branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.EvolutionaryTracking.Views/3.4/Plugin.cs
===================================================================
--- branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.EvolutionaryTracking.Views/3.4/Plugin.cs	(revision 9834)
+++ branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.EvolutionaryTracking.Views/3.4/Plugin.cs	(revision 9835)
@@ -27,4 +27,6 @@
   [PluginDependency("HeuristicLab.Core", "3.3")]
   [PluginDependency("HeuristicLab.Core.Views", "3.3")]
+  [PluginDependency("HeuristicLab.Common", "3.3")]
+  [PluginDependency("HeuristicLab.Common.Resources", "3.3")]
   [PluginDependency("HeuristicLab.Encodings.SymbolicExpressionTreeEncoding", "3.4")]
   [PluginDependency("HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views", "3.4")]
Index: branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.EvolutionaryTracking/3.4/Analyzers/BuildingBlocks/Poly10BuildingBlocksAnalyzer.cs
===================================================================
--- branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.EvolutionaryTracking/3.4/Analyzers/BuildingBlocks/Poly10BuildingBlocksAnalyzer.cs	(revision 9834)
+++ branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.EvolutionaryTracking/3.4/Analyzers/BuildingBlocks/Poly10BuildingBlocksAnalyzer.cs	(revision 9835)
@@ -206,5 +206,5 @@
         n.AddSubtree(x1);
         n.AddSubtree(x2);
-        var bb = new BuildingBlock { Name = "(* x1 x2)", Fragment = new Fragment(n) };
+        var bb = new BuildingBlock { Name = "(* x1 x2)", Fragment = new Fragment { Root = n } };
         buildingBlockGroups.Add(new BuildingBlockGroup { Name = "(* x1 x2)", BuildingBlocks = new List<BuildingBlock> { bb } });
       }
@@ -215,5 +215,5 @@
         n.AddSubtree(x3);
         n.AddSubtree(x4);
-        var bb = new BuildingBlock { Name = "(* x3 x4)", Fragment = new Fragment(n) };
+        var bb = new BuildingBlock { Name = "(* x3 x4)", Fragment = new Fragment { Root = n } };
         buildingBlockGroups.Add(new BuildingBlockGroup { Name = "(* x3 x4)", BuildingBlocks = new List<BuildingBlock> { bb } });
       }
@@ -225,5 +225,5 @@
         n.AddSubtree(x5);
         n.AddSubtree(x6);
-        var bb = new BuildingBlock { Name = "(* x5 x6)", Fragment = new Fragment(n) };
+        var bb = new BuildingBlock { Name = "(* x5 x6)", Fragment = new Fragment { Root = n } };
         buildingBlockGroups.Add(new BuildingBlockGroup { Name = "(* x5 x6)", BuildingBlocks = new List<BuildingBlock> { bb } });
       }
@@ -241,5 +241,5 @@
           m1.AddSubtree(m2);
           m1.AddSubtree(x1);
-          var bb = new BuildingBlock { Name = "(* (* x7 x9) x1)", Fragment = new Fragment(m1) };
+          var bb = new BuildingBlock { Name = "(* (* x7 x9) x1)", Fragment = new Fragment { Root = m1 } };
           group.BuildingBlocks.Add(bb);
         }
@@ -255,5 +255,5 @@
           m1.AddSubtree(m2);
           m1.AddSubtree(x7);
-          var bb = new BuildingBlock { Name = "(* (* x1 x9) x7)", Fragment = new Fragment(m1) };
+          var bb = new BuildingBlock { Name = "(* (* x1 x9) x7)", Fragment = new Fragment { Root = m1 } };
           group.BuildingBlocks.Add(bb);
         }
@@ -268,5 +268,5 @@
           m1.AddSubtree(m2);
           m1.AddSubtree(x9);
-          var bb = new BuildingBlock { Name = "(* (* x1 x7) x9)", Fragment = new Fragment(m1) };
+          var bb = new BuildingBlock { Name = "(* (* x1 x7) x9)", Fragment = new Fragment { Root = m1 } };
           group.BuildingBlocks.Add(bb);
         }
@@ -286,5 +286,5 @@
           m1.AddSubtree(m2);
           m1.AddSubtree(x3);
-          var bb = new BuildingBlock { Name = "(* (* x6 x10) x3)", Fragment = new Fragment(m1) };
+          var bb = new BuildingBlock { Name = "(* (* x6 x10) x3)", Fragment = new Fragment { Root = m1 } };
           group.BuildingBlocks.Add(bb);
         }
@@ -300,5 +300,5 @@
           m1.AddSubtree(m2);
           m1.AddSubtree(x6);
-          var bb = new BuildingBlock { Name = "(* (* x3 x10) x6)", Fragment = new Fragment(m1) };
+          var bb = new BuildingBlock { Name = "(* (* x3 x10) x6)", Fragment = new Fragment { Root = m1 } };
           group.BuildingBlocks.Add(bb);
         }
@@ -314,5 +314,5 @@
           m1.AddSubtree(m2);
           m1.AddSubtree(x10);
-          var bb = new BuildingBlock { Name = "(* (* x3 x6) x10)", Fragment = new Fragment(m1) };
+          var bb = new BuildingBlock { Name = "(* (* x3 x6) x10)", Fragment = new Fragment { Root = m1 } };
           group.BuildingBlocks.Add(bb);
         }
Index: branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.EvolutionaryTracking/3.4/Analyzers/BuildingBlocks/RelevantBuildingBlocksAnalyzer.cs
===================================================================
--- branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.EvolutionaryTracking/3.4/Analyzers/BuildingBlocks/RelevantBuildingBlocksAnalyzer.cs	(revision 9834)
+++ branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.EvolutionaryTracking/3.4/Analyzers/BuildingBlocks/RelevantBuildingBlocksAnalyzer.cs	(revision 9835)
@@ -33,5 +33,4 @@
 
     #region Parameters
-
     public ValueParameter<IntValue> UpdateIntervalParameter {
       get { return (ValueParameter<IntValue>)Parameters[UpdateIntervalParameterName]; }
@@ -102,4 +101,5 @@
 
     public RelevantBuildingBlocksAnalyzer() {
+      #region Parameters add
       Parameters.Add(new ScopeTreeLookupParameter<ISymbolicExpressionTree>(SymbolicExpressionTreeParameterName, "The symbolic expression trees to analyze."));
       Parameters.Add(new ValueParameter<IntValue>(UpdateIntervalParameterName, "The interval in which the tree length analysis should be applied.", new IntValue(1)));
@@ -114,5 +114,5 @@
       Parameters.Add(new LookupParameter<ISymbolicExpressionGrammar>(ClonedSymbolicExpressionTreeGrammarParameterName, "An immutable clone of the concrete grammar that is actually used to create and manipulate trees."));
       Parameters.Add(new LookupParameter<ISymbolicRegressionSolution>(SymbolicRegressionSolutionParameterName, "The symbolic regression solution."));
-
+      #endregion
       foundFragments = new Dictionary<string, IFragment>();
     }
@@ -147,7 +147,7 @@
       var bestTrainingSolution = (ISymbolicRegressionSolution)Results["Best training solution"].Value;
       var bestIndividual = bestTrainingSolution.Model.SymbolicExpressionTree;
-      var subtrees = bestIndividual.IterateNodesPrefix().Where(node => node.SubtreeCount > 0);
+      var subtrees = bestIndividual.IterateNodesPrefix().Where(node => node.SubtreeCount > 0).Select((node, index) => new { Node = node, Index = index });
       var frequentFragments = (from s in subtrees
-                               let fragment = new Fragment(s)
+                               let fragment = new Fragment { Root = s.Node, Index = s.Index }
                                let count = SymbolicExpressionTrees.Count(tree => tree.Root.ContainsFragment(fragment, comparer))
                                let frequency = (double)count / SymbolicExpressionTrees.Length
Index: branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.EvolutionaryTracking/3.4/Analyzers/SymbolicExpressionTreeEvolvabilityAnalyzer.cs
===================================================================
--- branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.EvolutionaryTracking/3.4/Analyzers/SymbolicExpressionTreeEvolvabilityAnalyzer.cs	(revision 9834)
+++ branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.EvolutionaryTracking/3.4/Analyzers/SymbolicExpressionTreeEvolvabilityAnalyzer.cs	(revision 9835)
@@ -38,5 +38,5 @@
 
     #region Parameter properties
-    LookupParameter<IRandom> RandomParameter {
+    public LookupParameter<IRandom> RandomParameter {
       get { return (LookupParameter<IRandom>)Parameters[RandomParameterName]; }
     }
Index: branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.EvolutionaryTracking/3.4/Analyzers/SymbolicExpressionTreeFrequentPatternsAnalyzer.cs
===================================================================
--- branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.EvolutionaryTracking/3.4/Analyzers/SymbolicExpressionTreeFrequentPatternsAnalyzer.cs	(revision 9834)
+++ branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.EvolutionaryTracking/3.4/Analyzers/SymbolicExpressionTreeFrequentPatternsAnalyzer.cs	(revision 9835)
@@ -318,5 +318,5 @@
           var symbol = availableSymbols.SelectRandom(weights, random);
           var fragment = CreateFragment(symbol, random, grammar, threshold, maxDepth, maxLength, EnforceGrammarArity.Value);
-          fragments.Add(new Fragment(fragment));
+          fragments.Add(new Fragment { Root = fragment });
         }
       return fragments;
Index: branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.EvolutionaryTracking/3.4/Analyzers/SymbolicExpressionTreePopulationDiversityAnalyzer.cs
===================================================================
--- branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.EvolutionaryTracking/3.4/Analyzers/SymbolicExpressionTreePopulationDiversityAnalyzer.cs	(revision 9834)
+++ branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.EvolutionaryTracking/3.4/Analyzers/SymbolicExpressionTreePopulationDiversityAnalyzer.cs	(revision 9835)
@@ -21,5 +21,4 @@
 
 using System.Linq;
-using System.Threading;
 using HeuristicLab.Analysis;
 using HeuristicLab.Common;
@@ -66,84 +65,50 @@
       get { return (IValueLookupParameter<IntValue>)Parameters[MaximumSymbolicExpressionTreeDepthParameterName]; }
     }
-
     public ValueParameter<IntValue> UpdateIntervalParameter {
       get { return (ValueParameter<IntValue>)Parameters[UpdateIntervalParameterName]; }
     }
-
     public ValueParameter<IntValue> UpdateCounterParameter {
       get { return (ValueParameter<IntValue>)Parameters[UpdateCounterParameterName]; }
     }
-
     public LookupParameter<ResultCollection> ResultsParameter {
       get { return (LookupParameter<ResultCollection>)Parameters[ResultsParameterName]; }
     }
-
     public LookupParameter<IntValue> GenerationsParameter {
       get { return (LookupParameter<IntValue>)Parameters[GenerationsParameterName]; }
     }
-
     public ValueParameter<BoolValue> StoreHistoryParameter {
       get { return (ValueParameter<BoolValue>)Parameters[StoreHistoryParameterName]; }
     }
-
     public IScopeTreeLookupParameter<ISymbolicExpressionTree> SymbolicExpressionTreeParameter {
       get { return (IScopeTreeLookupParameter<ISymbolicExpressionTree>)Parameters[SymbolicExpressionTreeParameterName]; }
     }
-
     public ValueParameter<BoolValue> MatchVariableNamesParameter {
       get { return (ValueParameter<BoolValue>)Parameters[MatchVariablesParameterName]; }
     }
-
     public ValueParameter<BoolValue> MatchVariableWeightsParameter {
       get { return (ValueParameter<BoolValue>)Parameters[MatchVariableWeightsParameterName]; }
     }
-
     public ValueParameter<BoolValue> MatchConstantValuesParameter {
       get { return (ValueParameter<BoolValue>)Parameters[MatchConstantValuesParameterName]; }
     }
-
     public ValueParameter<BoolValue> SortSubtreesParameter {
       get { return (ValueParameter<BoolValue>)Parameters[SortSubtreesParameterName]; }
     }
-
     public LookupParameter<CloneMapType> GlobalCloneMapParameter {
       get { return (LookupParameter<CloneMapType>)Parameters[GlobalCloneMapParameterName]; }
     }
-
     public ILookupParameter<DoubleValue> SimilarityParameter {
       get { return (ILookupParameter<DoubleValue>)Parameters[SimilarityValuesParmeterName]; }
     }
-
     #endregion
 
     #region Parameter properties
-    public IntValue MaximumSymbolicExpressionTreeDepth {
-      get { return MaximumSymbolicExpressionTreeDepthParameter.ActualValue; }
-    }
-
-    public IntValue UpdateInterval {
-      get { return UpdateIntervalParameter.Value; }
-    }
-
-    public IntValue UpdateCounter {
-      get { return UpdateCounterParameter.Value; }
-    }
-
-    public ResultCollection Results {
-      get { return ResultsParameter.ActualValue; }
-    }
-
-    public CloneMapType GlobalCloneMap {
-      get { return GlobalCloneMapParameter.ActualValue; }
-    }
-
-    public IntValue Generations {
-      get { return GenerationsParameter.ActualValue; }
-    }
-
-    public BoolValue StoreHistory {
-      get { return StoreHistoryParameter.Value; }
-    }
-
+    public IntValue MaximumSymbolicExpressionTreeDepth { get { return MaximumSymbolicExpressionTreeDepthParameter.ActualValue; } }
+    public IntValue UpdateInterval { get { return UpdateIntervalParameter.Value; } }
+    public IntValue UpdateCounter { get { return UpdateCounterParameter.Value; } }
+    public ResultCollection Results { get { return ResultsParameter.ActualValue; } }
+    public CloneMapType GlobalCloneMap { get { return GlobalCloneMapParameter.ActualValue; } }
+    public IntValue Generations { get { return GenerationsParameter.ActualValue; } }
+    public BoolValue StoreHistory { get { return StoreHistoryParameter.Value; } }
     #endregion
 
Index: branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.EvolutionaryTracking/3.4/GenericGraph/Arc.cs
===================================================================
--- branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.EvolutionaryTracking/3.4/GenericGraph/Arc.cs	(revision 9834)
+++ branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.EvolutionaryTracking/3.4/GenericGraph/Arc.cs	(revision 9835)
@@ -8,24 +8,28 @@
   /// </summary>
   [StorableClass]
-  public class Arc : Item, IEdge
-  {
-    [Storable] private IVertex source;
+  public class Arc : Item, IEdge {
+    [Storable]
+    private IVertex source;
     public IVertex Source { get { return source; } set { source = value; } }
-    [Storable] private IVertex target;
+    [Storable]
+    private IVertex target;
     public IVertex Target { get { return target; } set { target = value; } }
-    [Storable] private string label;
+    [Storable]
+    private string label;
     public string Label { get { return label; } set { label = value; } }
-    [Storable] private double weight;
+    [Storable]
+    private double weight;
     public double Weight { get { return weight; } set { weight = value; } }
-    [Storable] private object data;
+    [Storable]
+    private object data;
     public object Data { get { return data; } set { data = value; } }
 
     [StorableConstructor]
-    public Arc(bool deserializing) : base(deserializing) {}
+    public Arc(bool deserializing) : base(deserializing) { }
 
-    public Arc() {}
+    public Arc() { }
 
-    private Arc(Arc original, Cloner cloner) : base(original, cloner)
-    {
+    private Arc(Arc original, Cloner cloner)
+      : base(original, cloner) {
       Source = original.Source;
       Target = original.Target;
@@ -35,6 +39,5 @@
     }
 
-    public override IDeepCloneable Clone(Cloner cloner)
-    {
+    public override IDeepCloneable Clone(Cloner cloner) {
       return new Arc(this, cloner);
     }
Index: branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.EvolutionaryTracking/3.4/GenericGraph/Vertex.cs
===================================================================
--- branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.EvolutionaryTracking/3.4/GenericGraph/Vertex.cs	(revision 9834)
+++ branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.EvolutionaryTracking/3.4/GenericGraph/Vertex.cs	(revision 9835)
@@ -28,18 +28,22 @@
 namespace HeuristicLab.EvolutionaryTracking {
   [StorableClass]
-  public class Vertex : Item, IVertex
-  {
+  public class Vertex : Item, IVertex {
     [Storable]
     private string id;
     public string Id { get { return id; } }
-    [Storable] private string label;
+    [Storable]
+    private string label;
     public string Label { get { return label; } set { label = value; } }
-    [Storable] private double weight;
+    [Storable]
+    private double weight;
     public double Weight { get { return weight; } set { weight = value; } }
-    [Storable] private List<IEdge> inEdges; 
+    [Storable]
+    private List<IEdge> inEdges;
     public List<IEdge> InEdges { get { return inEdges; } private set { inEdges = value; } }
-    [Storable] private List<IEdge> outEdges;
-    public List<IEdge> OutEdges { get { return outEdges; }private set { outEdges = value; }}
-    [Storable] private object content;
+    [Storable]
+    private List<IEdge> outEdges;
+    public List<IEdge> OutEdges { get { return outEdges; } private set { outEdges = value; } }
+    [Storable]
+    private object content;
     public object Content {
       get { return content; }
@@ -59,6 +63,5 @@
 
     [StorableHook(HookType.AfterDeserialization)]
-    private void AfterDeserialization()
-    {
+    private void AfterDeserialization() {
       if (id == null) {
         id = Guid.NewGuid().ToString();
Index: branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.EvolutionaryTracking/3.4/HeuristicLab.EvolutionaryTracking-3.4.csproj
===================================================================
--- branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.EvolutionaryTracking/3.4/HeuristicLab.EvolutionaryTracking-3.4.csproj	(revision 9834)
+++ branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.EvolutionaryTracking/3.4/HeuristicLab.EvolutionaryTracking-3.4.csproj	(revision 9835)
@@ -115,7 +115,4 @@
       <Private>False</Private>
     </Reference>
-    <Reference Include="HeuristicLab.Problems.DataAnalysis.Symbolic.Views-3.4, Version=3.4.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
-      <Private>False</Private>
-    </Reference>
     <Reference Include="HeuristicLab.Random-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
       <SpecificVersion>False</SpecificVersion>
@@ -134,11 +131,13 @@
   </ItemGroup>
   <ItemGroup>
+    <Compile Include="Analyzers\BuildingBlocks\BuildingBlockHistoryAnalyzer.cs" />
     <Compile Include="Analyzers\BuildingBlocks\RelevantBuildingBlocksAnalyzer.cs" />
     <Compile Include="Analyzers\BuildingBlocks\Poly10BuildingBlocksAnalyzer.cs" />
+    <Compile Include="Analyzers\LineageRetrofittingAnalyzer.cs" />
+    <Compile Include="Analyzers\SymbolicExpressionTreePruningAnalyzer.cs" />
     <Compile Include="Analyzers\SymbolicExpressionTreeShapeAnalyzer.cs" />
     <Compile Include="Analyzers\SymbolicExpressionTreeEvolvabilityAnalyzer.cs" />
     <Compile Include="Analyzers\Fragments\SymbolicExpressionTreeRelativeFragmentDepthAnalyzer.cs" />
     <Compile Include="Analyzers\Fragments\SymbolicExpressionTreeFragmentLengthsAnalyzer.cs" />
-    <Compile Include="Analyzers\GeneticOperatorImprovementAnalyzer.cs" />
     <Compile Include="Analyzers\SymbolicExpressionTreeFrequentPatternsAnalyzer.cs" />
     <Compile Include="Analyzers\Fragments\SymbolicExpressionTreeFragmentsAnalyzer.cs" />
@@ -164,5 +163,4 @@
     <Compile Include="SymbolGraph.cs" />
     <Compile Include="SymbolicExpressionTreeGenealogyGraph.cs" />
-    <Compile Include="TreeDistance\TreeDistanceCalculator.cs" />
   </ItemGroup>
   <ItemGroup />
